var formCurrentSet = {};
var formCurrentContainerID = '';
var formGroupPos = {};
var kediaman = {}; 
var but_kediaman = {};
var kk = {};
var ir = {};
var kampung_list = {};

function renderForm(containerID, qSet, readonly){
	var hasMap;
	var groups = [];
	var groups_tab = '';
	var output = '<form>';
	
	
	
	
	formCurrentSet = qSet;
	formCurrentContainerID = containerID;
	
	eval('var obj = '+qSet._object_bind);
	
	if (!obj) obj = {};
	
	
	for (var field in qSet){
		var opt = qSet[field];

		if (obj[field] === undefined) obj[field] = '';
		
		if (field != '_object_bind'){
			
			
			var value = obj[field];
			
			if (opt.readonly){
				// do nothing for now
			} else if (opt.type == 'group'){
				
				groups.push(opt.label)
				
				output += '<div rel="'+opt.label+'" class="group bg-gray-300 text-xl font-bold px-4 py-2">'+opt.label+'</div>';
				
			} else {
			
				output += '<div id="q-'+field+'" class="qcontainer bg-white m-2 rounded shadow px-3 py-3 '+(opt.mandatory ? 'mandatory' : '')+'">';
				output += '<div class="question text-sm text-gray-500">'+opt.label+(opt.mandatory ? ' <span class="text-red-500">*</span>' : '')+'</div>';
				
				if (opt.type == 'text'){
					output += '<div class="answer"><input autocomplete="off" value="'+obj[field]+'" '+(readonly ? 'readonly' : 'onkeyup="validateForm(this)"')+' class="'+(opt.mandatory ? 'mandatory' : '')+' appearance-none w-full py-1 transition-all outline-none border-b-2 border-gray-300 focus:border-blue-700" type="text" name="'+field+'" /></div>';
				}
				
				if (opt.type == 'email'){
					output += '<div class="answer"><input autocomplete="off"  value="'+obj[field]+'" '+(readonly ? 'readonly' : 'onkeyup="validateForm(this)"')+' class="'+(opt.mandatory ? 'mandatory' : '')+' appearance-none w-full py-1 transition-all outline-none border-b-2 border-gray-300 focus:border-blue-700" type="email" name="'+field+'" /></div>';
				}
				
				if (opt.type == 'date'){
					output += '<div class="answer"><input autocomplete="off" value="'+obj[field]+'" '+(readonly ? 'readonly' : 'onkeyup="validateForm(this)"')+' class="'+(opt.mandatory ? 'mandatory' : '')+' appearance-none bg-white w-full py-1 transition-all outline-none border-b-2 border-gray-300 focus:border-blue-700" type="date" name="'+field+'" /></div>';
				}
				
				if (opt.type == 'tel'){
					output += '<div class="answer"><input autocomplete="off" value="'+obj[field]+'" '+(readonly ? 'disabled' : 'onkeyup="validateForm(this)"')+' class="'+(opt.mandatory ? 'mandatory' : '')+' appearance-none w-full py-1 transition-all outline-none border-b-2 border-gray-300 focus:border-blue-700" type="tel" name="'+field+'" /></div>';
				}
				
				if (opt.type == 'number'){
					output += '<div class="answer"><input autocomplete="off" value="'+obj[field]+'" '+(readonly ? 'disabled' : 'onkeyup="validateForm(this)"')+' class="'+(opt.mandatory ? 'mandatory' : '')+' appearance-none w-full py-1 transition-all outline-none border-b-2 border-gray-300 focus:border-blue-700" type="number" name="'+field+'" /></div>';
				}
				
				if (opt.type == 'dropdown'){
					output += '<select '+(readonly ? 'disabled' : 'onchange="validateForm(this)"')+' placeholder="Sila Pilih" class="appearance-none bg-white w-full px-0 py-1 h-8 border-b-2 border-gray-300 focus:border-blue-700 transition-all outline-none '+(opt.mandatory ? 'mandatory' : '')+'"  name="'+field+'">';
					output += '<option value="">Sila pilih</option>';
					
					if (opt.order){
						for (var o in opt.order){
							var i = opt.order[o];
							if (Array.isArray(opt.source)){
								output += '<option '+(obj[field] == opt.source[i] ? 'selected' : '')+' value="'+opt.source[i]+'">'+opt.source[i]+'</option>';
							} else {
								output += '<option '+(obj[field] == i ? 'selected' : '')+' value="'+i+'">'+opt.source[i]+'</option>';
							}
						}
					} else {
						for (var i in opt.source){
							if (Array.isArray(opt.source)){
								output += '<option '+(obj[field] == opt.source[i] ? 'selected' : '')+' value="'+opt.source[i]+'">'+opt.source[i]+'</option>';
							} else {
								output += '<option '+(obj[field] == i ? 'selected' : '')+' value="'+i+'">'+opt.source[i]+'</option>';
							}
						}
					}
					
					output += '</select>';
				}
				
				if (opt.type == 'radio'){
					
					for (var i in opt.source){
						if (Array.isArray(opt.source)){
							output += '<label class="block text-sm py-1"><input ' + (value == opt.source[i] ? 'checked' : '') + ' '+(readonly ? 'disabled' : 'onclick="validateForm(this)"')+' type="radio" name="'+field+'" value="'+opt.source[i]+'" /> '+opt.source[i]+'</label>';
						} else {
							output += '<label class="block text-sm py-1"><input ' + (value == i ? 'checked' : '') + ' '+(readonly ? 'disabled' : 'onclick="validateForm(this)"')+' type="radio" name="'+field+'" value="'+i+'" /> '+opt.source[i]+'</label>';
						}
					}
				}
				
				if (opt.type == 'map'){
					output += '<div style="height: 200px; margin: 5px 0; background: #eee; width: 100%; border-radius: 5px;" id="map"></div><div id="map-coordinates" class="text-sm pt-1"></div><input type="hidden" name="'+field+'" />';
					  
					hasMap = true;
				}
				
				if (opt.type == 'checkbox'){
					
					var selected = [];
					
					for (var i in obj[field]){
						selected[obj[field][i]] = true;
					}
					
					for (var i in opt.source){
						if (Array.isArray(opt.source)){
							output += '<label class="block text-sm py-1"><input ' + (selected[opt.source[i]] ? 'checked' : '') + ' '+(readonly ? 'disabled' : 'onclick="validateForm(this)"')+' type="checkbox" name="'+field+'[]" value="'+opt.source[i]+'" /> '+opt.source[i]+'</label>';
						} else {
							output += '<label class="block text-sm py-1"><input ' + (selected[i] ? 'checked' : '') + ' '+(readonly ? 'disabled' : 'onclick="validateForm(this)"')+' type="checkbox" name="'+field+'[]" value="'+i+'" /> '+opt.source[i]+'</label>';
						}
					}
				}
				
				output += '</div>';
				
			}
		}
	}
	
	output += '</form>';
	
	if (groups.length > 0){
		groups_tab += '<div class="fixed z-10 shadow-md tab-container overflow-x-scroll  whitespace-nowrap bg-white left-0 right-0" style="top: 48px">';
		var n = 0;
		for (var i in groups){
			groups_tab += '<a onclick="formScrollTo(\''+groups[i]+'\')" rel="'+groups[i]+'" class="group-tabs px-3 '+(n == 0 ? 'font-bold text-blue-700 border-b-2 border-blue-700' : '')+' py-3 inline-block">'+groups[i]+'</a>';
			n++;
		}
		groups_tab += '</div>';
		groups_tab += '<div style="height: 50px"></div>';
	}
	
	var form = document.getElementById(containerID);
	form.innerHTML = groups_tab + output;
	
	if (groups_tab){
		var formPageContent = document.querySelector('.page-current .page-content');
		formPageContent.onscroll = function(){
			formScrollBind(formPageContent);
		}
	}
	
	
	validateForm()
	
	
	if (hasMap && !readonly){

		startCheckLocation();
	}
}

function validateForm(){
	var ok = true;
	
	
	eval(formCurrentSet._object_bind + ' = formSerialize()');
	
	for (var field in formCurrentSet){
		
		if (formCurrentSet[field].show){
			if (formCurrentSet[field].show()){
				document.getElementById('q-'+field).classList.remove('hidden');
			} else {
				document.getElementById('q-'+field).classList.add('hidden');
			}
		}
	}
	
	formGroupPos = [];
	document.querySelectorAll('.group').forEach(function(el){
		formGroupPos[el.offsetTop] = el.innerHTML;
	})
	
	document.querySelectorAll('input.mandatory').forEach(function(el){
		if (!el.value) ok = false;
	})
	
	document.querySelectorAll('select.mandatory').forEach(function(el){
		if (!el.value) ok = false;
	})

	
	app.formOK = ok;
}

function formSerialize(){
	
	var serialized = {};
	
	for (var field in formCurrentSet){
		

		switch (formCurrentSet[field].type){
			case "text":
			case "email":
			case "number":
			case "tel":
			case "date":
			case "map":
			case "dropdown":
				serialized[field] = document.querySelector('form [name='+field+']').value;
				
				break;
			case "radio":
			
				document.querySelectorAll('form input[name='+field+']').forEach(function(el){
					if (el.checked){
						serialized[field] = el.value;
					}
				})
			
				break;
			case "checkbox":
			
				var values = [];
				document.querySelectorAll('form input[name='+field+']').forEach(function(el){
					if (el.checked){
						values.push(el.value)
					}
				})
				
				serialized[field] = values;
			
				break;
				
			
		}
	}

	
	return serialized;
	
}

function formScrollBind(el){
	var top = el.scrollTop;
	var rel = 'Profil Umum';
	for (var t in formGroupPos){
		if (top > t - 200){
			rel = formGroupPos[t];
		}
	}
	
	
	document.querySelectorAll('.group-tabs').forEach(function(tab){
		tab.classList.remove('font-bold', 'text-blue-700', 'border-b-2', 'border-blue-700');
	})
	
	var currentTab = document.querySelector('.group-tabs[rel="'+rel+'"]')
	currentTab.classList.add('font-bold', 'text-blue-700', 'border-b-2', 'border-blue-700');
		
	
	var offset = currentTab.offsetLeft;
	document.querySelector('.tab-container').scrollLeft += Math.round(offset) - 100
	
}

function formScrollTo(group){
	var group = document.querySelector('.group[rel="'+group+'"]');
	var form = document.getElementById(formCurrentContainerID);
	
	form.scrollTop = group.offsetTop - 50;
}

var fixedMarker;

function startMap(position){
	
	var latlon = position.coords.latitude.toFixed(6) + ", " + position.coords.longitude.toFixed(6);
	
	document.getElementById('map-coordinates').innerHTML = latlon;
	
	map = new google.maps.Map(document.getElementById("map"), {
		center: { 
			lat: position.coords.latitude, 
			lng: position.coords.longitude 
		},
		zoomControl: false,
		mapTypeControl: false,
		streetViewControl: false,
		fullscreenControl: false,
		zoom: 15,
		gestureHandling: "greedy"
	});
	
	google.maps.event.addListener(map, 'dragend', function() {
		
		var mapCenter = map.getCenter();
		var latlon = mapCenter.lat() + ", " + mapCenter.lng();
		
		document.getElementById('map-coordinates').innerHTML = latlon;
		fixedMarker.setPosition(map.getCenter());
	
	})
		
	
	fixedMarker = new google.maps.Marker({
		position: {
			lat: position.coords.latitude, 
			lng: position.coords.longitude 
		},
		map
	});
}

function startCheckLocation(){
	if (navigator.geolocation) {
		navigator.geolocation.getCurrentPosition(startMap);
	} else {
		alert('Geolocation not supported');
	}
}

// to load kampung master list on login

var kampung = {
	poskod: '',
	bandar: '',
	zon: '',
	daerah: '',
	mukim: '',
	parlimen: '',
	dun: ''
}

var sKediaman = {
	alamat_1: {
		label: 'Alamat 1',
		type: 'text',
		mandatory: true
	},
	alamat_2: {
		label: 'Alamat 2',
		type: 'text',
		
	},
	kampung: {
		label: 'Kampung',
		type: 'dropdown',
		source: kampung_list,
		value: 'id',
		display: 'nama',
		mandatory: true,
		onchange: function(val){
			kampung = kampung_list[val]
		}
	},
	latlng: {
		label: 'Lokasi',
		type: 'map'
	}
}

var qKediaman = {
	_object_bind: 'but_kediaman',
	jen_kediaman: {
		label: 'Jenis Kediaman',
		type: 'dropdown',
		source: ['Perumahan Ketengah', 'PPRT', 'Rumah Felda', 'Rumah Mesra Rakyat', 'Kuarters Kerajaan', 'Lain-lain']
	},
	jen_rumah: {
		label: 'Jenis/Unit Rumah',
		type: 'dropdown',
		source: ['Sesebuah','Berkembar','Teres','Rumah Pangsa','Rumah Kedai','Lain-lain']
	},
	bahan: {
		label: 'Bahan Binaan Rumah',
		type: 'dropdown',
		source: ['Batu','Papan','Batu & Papan','Lain-lain']
	}, 
	didiami: {
		label: 'Adakah Tempat Kediaman ini didiami atau kosong',
		type: 'dropdown',
		source: {
			'1': 'Didiami',
			'2': 'Kosong - Baru siap/Untuk disewa',
			'3': 'Kosong - Untuk dibaiki',
			'4': 'Kosong - Rumah Peranginan',
			'5': 'Kosong - Hampir roboh',
			'6': 'Lain-lain'
		}
	},
	bil_bilik: {
		label: 'Bilangan bilik',
		type: 'text',
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	status_milik: {
		label: 'Status pemilikan kediaman',
		type: 'dropdown',
		source: {
			'1': 'Milik Individu/ Persendirian',
			'2': 'Kerajaan/ Badan Berkanun',
			'3': 'Pihak Berkuasa Tempatan',
			'4': 'Pihak Swasta',
			'5': 'Koperasi',
			'6': 'Lain-lain'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	pemilik_penyewa: {
		label: 'Adakah kediaman ini dimiliki atau disewa?',
		type: 'radio',
		source: {
			'1': 'Dimiliki',
			'2': 'Disewa',
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	kaedah: {
		label: 'Apakah kaedah pemilikan kediaman anda',
		type: 'dropdown',
		source: {
			'1': 'Sewa Beli dengan Ketengah',
			'2': 'Hadiah/Pusaka',
			'3': 'Pembinaan/ Pembiayaan Sendiri',
			'4': 'Pembelian tunai',
			'5': 'Pinjaman Institusi Kewangan',
			'6': 'Bantuan Kerajaan/Swasta/NGO'
		},
		show: function(){
			return but_kediaman.didiami == '1' && but_kediaman.pemilik_penyewa == '1' ? true : false
		}
	},
	sewa: {
		label: 'Berapakah sewa bulanan semasa yang dibayar untuk tempat kediaman ini?',
		type: 'number',
		show: function(){
			return but_kediaman.didiami == '1' && but_kediaman.pemilik_penyewa == '2' ? true : false
		}
	},
	sebab_menyewa: {
		label: 'Apakah sebab anda menyewa di kediaman ini?',
		type: 'radio',
		source: {
			'1': 'Bekerja di kawasan ini',
			'2': 'Generasi ke 2/3 yang memerlukan kediaman di tempat kelahiran sendiri'
		},
		show: function(){
			return but_kediaman.didiami == '1' && but_kediaman.pemilik_penyewa == '2' ? true : false
		}
	},
	b_pendapatan: {
		label: 'Berapakah anggaran jumlah pendapatan kasar bulanan yang diterima oleh Isi Rumah ini daripada pelbagai sumber?',
		type: 'dropdown',
		source: {
			'1': 'Kurang daripada RM1,311',
			'2': 'RM1,312 - RM2,477',
			'3': 'RM2,478 - RM4,850',
			'4': 'RM4,851 - RM10,970',
			'5': 'Lebih daripada RM10,971',
			'6': 'Tiada Pendapatan'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	lampu: {
		label: 'Terdapat lampu jalan sekitar kediaman anda?',
		type: 'radio',
		source: {
			'1': 'Ya',
			'2': 'Tidak'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	awam: {
		label: 'Adakan kawasan ini mempunyai akses kepada pengangkutan awam?',
		type: 'radio',
		source: {
			'1': 'Ya',
			'2': 'Tidak'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	pelancongan: {
		label: 'Apakah terdapat kemudahan Pelancongan di kawasan kediaman ini?',
		type: 'radio',
		source: {
			'1': 'Ya',
			'2': 'Tidak'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	kemudahan_asas: {
		label: 'Kemudahan Asas',
		type: 'checkbox',
		source: ['Bekalan Air dari SATU', 'Perkhidmatan Bekalan Elektrik dari TNB','Jalan Berturap', 'Sistem Pembentungan Berpusat', 'Telekomunikasi', 'Tiada'],
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	tempat_sampah: {
		label: 'Adakah tempat pembuangan sampah disediakan di tempat anda?',
		type: 'radio',
		source: {
			'1': 'Ya',
			'2': 'Tidak'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	khidmat_sampah: {
		label: 'Adakah terdapat perkhidmatan kutipan sampah di tempat kediaman/kawasan ini?',
		type: 'radio',
		source: {
			'1': 'Ya',
			'2': 'Tidak'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	parit: {
		label: 'Apakah jenis sistem perparitan di kawasan anda',
		type: 'dropdown',
		source: [
			'Tiada sistem',
			'Parit tanah',
			'Sistem longkang konkrit'
		],
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	banjir: {
		label: 'Adakah kawasan sekitar kediaman anda terlibat dengan bencana banjir',
		type: 'radio',
		source: {
			'1': 'Ya',
			'2': 'Tidak'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	kawalan: {
		label: 'Adakah kawasan kediaman ini mempunyai kawalan keselamatan berikut?',
		type: 'checkbox',
		source: [
			'Kawalan Keselamatan Persendirian/Swasta',
			'Kawalan Keselamatan Komuniti',
			'RELA',
			'Polis',
			'Lain-lain',
			'Tiada'
		],
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	risiko: {
		label: 'Adakah kawasan kediaman anda berisiko dengan jenayah sebagaimana berikut?',
		type: 'checkbox',
		source: [
			'Kecurian',
			'Rogol',
			'Bunuh',
			'Dadah',
			'Vandalism',
			'Lain-lain',
			'Tiada'
		],
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	ciri: {
		label: 'Apakah ciri keselamatan yang terdapat di kawasan kediaman anda',
		type: 'checkbox',
		source: [
			'CCTV',
			'Kawalan keselamatan 24 jam sehari',
			'Pagar elektrik',
			'Pagar dawai/besi',
			'Lain-lain',
			'Tiada'
		],
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	},
	jarak_bp: {
		label: 'Berapakah jarak kediaman anda ke Balai Polis yang berhampiran?',
		type: 'dropdown',
		source: {
			'1': '0-5KM',
			'2': '6-10KM',
			'3': '11-20KM',
			'4': '21-30KM',
			'5': 'Lain-lain'
		},
		show: function(){
			return but_kediaman.didiami == '1' ? true : false
		}
	}
	
}

var qKK = {
	_object_bind: 'kk',
	profil_umum: {
		label: 'Profil Umum',
		type: 'group'	
	},
	
	ada_kp: {
		label: 'Adakah anda mempunyai dokumen pengenalan diri?',
		type: 'radio',
		source: ["Ya", "Tidak"]
	},
	jenis_kp: {
		label: 'Jenis Kad Pengenalan',
		type: 'dropdown',
		source: {
			'1': 'No.: MyKad / MyKid / MyPR / MyKAS / MyTentera',
			'2': 'No.: K.P. Lama / Tentera / Polis / Sijil Lahir / Pasport / Dokumen Lain',
			'3': 'No. Permit Kerja',
			'4': 'No. Pasport'
		},
		show: function(){
			return kk.ada_kp == 'Ya' ? true : false
		}
	},
	no_ic: {
		label: 'No Kad Pengenalan (tanpa simbol -)',
		type: 'text',
		show: function(){
			
			if (kk.no_ic){
				if (kk.no_ic.length == 12){
					var yy = kk.no_ic.charAt(0) + kk.no_ic.charAt(1);
					var mm = kk.no_ic.charAt(2) + kk.no_ic.charAt(3);
					var dd = kk.no_ic.charAt(4) + kk.no_ic.charAt(5);
					
					if (yy > 25){
						yy = 1900+parseInt(yy);
					} else {
						yy = 2000+parseInt(yy);
					}
					
					
					var birthday = new Date(yy, parseInt(mm), parseInt(dd));
					var ageDifMs = Date.now() - birthday.getTime();
					var ageDate = new Date(ageDifMs);
					var age = Math.abs(ageDate.getUTCFullYear() - 1970);
					
					if (kk.no_ic.charAt(kk.no_ic.length-1) % 2 == 0){
						document.querySelector('input[value=Perempuan]').checked = true;
					} else {
						document.querySelector('input[value=Lelaki]').checked = true;
					}
					
					document.querySelector('input[name=tarikh_lahir]').value = yy + '-' + mm + '-' + dd;
					document.querySelector('input[name=umur]').value = age;

					
					
				}
			}
			
			return kk.ada_kp == 'Ya' ? true : false
		}
	},
	nama: {
		label: "Nama",
		mandatory: true,
		type: 'text'
	},
	no_tel: {
		label: 'No Telefon',
		type: 'tel'
	},
	emel: {
		label: 'Emel',
		type: 'email'
	},
	jantina: {
		label: 'Jantina',
		type: 'radio',
		source: ["Lelaki", "Perempuan"]
	},
	tarikh_lahir: {
		label: 'Tarikh Lahir',
		type: 'date',
	},
	tempat_lahir: {
		label: 'Dimanakah tempat lahir anda?',
		type: 'dropdown',
		source: [
			'Johor',
			'Kedah',
			'Kelantan',
			'Melaka',
			'Negeri Sembilan',
			'Pahang',
			'Perak',
			'Perlis',
			'Pulau Pinang',
			'Sabah',
			'Sarawak',
			'Selangor',
			'Terengganu',
			'Wilayah Persekutuan'
		]
	},
	umur: {
		label: 'Umur',
		type: 'number'
	},
	kaum: {
		label: 'Kaum',
		type: 'dropdown',
		source: [
			'Melayu',
			'Cina',
			'India',
			'Lain-lain'
		],
	},
	agama: {
		label: 'Agama',
		type: 'dropdown',
		source: [
			'Islam',
			'Buddha',
			'Hindu',
			'Kristian',
			'Tiada Agama',
			'Lain-lain'
		]
	},
	status_kahwin: {
		label: 'Taraf Perkahwinan',
		type: 'dropdown',
		source: {
			'1': 'Tidak pernah berkahwin',
			'2': 'Berkahwin',
			'3': 'Balu/Duda',
			'4': 'Bercerai/Berpisah tetap'
		}
	},
	bil_anak: {
		label: 'Bilangan Anak',
		type: 'number',
		show: function(){
			return kk.status_kahwin == '1' ? false : true
		}
	},
	
	warganegara: {
		label: 'Adakah anda Warganegara Malaysia?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		]
	},
	tahun_my: {
		label: 'Berapa tahun anda telah berada di Malaysia?',
		type: 'dropdown',
		source: {
			'4': 'Kurang daripada 1 tahun',
			'1': '1-10 tahun',
			'2': '11-20 tahun',
			'3': '21 tahun ke atas'
		},
		show: function(){
			return kk.warganegara == 'Tidak' ? true : false
		}
	},
	status_duduk: {
		label: 'Apakah status kependudukan anda?',
		type: 'dropdown',
		source: [
			'Penduduk Tetap',
			'Ekspatriat',
			'Pelawat Asing',
			'Pekerja Asing',
			'Lain-lain'
		],
		show: function(){
			return kk.warganegara == 'Tidak' ? true : false
		}
	},
	tanah_lain: {
		label: 'Adakah anda mempunyai tanah selain daripada tanah pemilikan di dalam wilayah Ketengah ?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		]
	},
	lesen: {
		label: 'Lesen kenderaan yang anda miliki?',
		type: 'checkbox',
		source: [
			'B2-Motosikal',
			'B-Motosikal 500cc',
			'D-Kereta',
			'E-Lori',
			'E-GDL',
			'D-GDL',
			'PSV-Konduktor',
			'PSV-Bas',
			'PSV-Teksi',
			'Tiada'
		]
	},
	oku: {
		label: 'Adakah anda merupakan orang kurang upaya (OKU)',
		type: 'dropdown',
		source: {
			'1': 'Ya',
			'3': 'Tidak'
		}
	},
	penyakit: {
		label: 'Adakah anda telah disahkan menghidap penyakit berikut sekarang',
		type: 'checkbox',
		source: [
			'Kencing manis',
			'Darah tinggi',
			'Jantung',
			'Lain-lain',
			'Tiada'
		]
	},
	insurans: {
		label: 'Adakah anda mempunyai perlindungan insurans kesihatan?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		]
	},
	pekerjaan: {
		label: 'Pekerjaan',
		type: 'group'
	},
	sektor: {
		label: 'Sektor Pekerjaan',
		type: 'dropdown',
		source: {
			'1': 'Sektor Awam',
			'2': 'Sektor Swasta',
			'3': 'Usahawan / Bekerja Sendiri',
			'5': 'Tidak Bekerja',
			'6': 'Lain-lain'
		}
	},
	pengangkutan: {
		label: 'Bagaimanakah anda ke tempat kerja?',
		type: 'checkbox',
		source: [
			'Kenderaan awam',
			'Motosikal',
			'Kereta',
			'Basikal',
			'Berjalan Kaki'
		],
		show: function(){
			return kk.sektor == '5' ? false : true
		}
	},
	jarak: {
		label: 'Berapakah jarak kediaman ke tempat kerja?',
		type: 'dropdown',
		source: {
			'6': 'Kurang daripada 1KM',
			'1': '1-5KM',
			'2': '5-10KM',
			'3': '10-15KM',
			'4': '15-20KM',
			'5': 'Lebih dari 20KM'
		},
		order: ['6','1','2','3','4','5'],
		show: function(){
			return kk.sektor == '5' ? false : true
		}
	},
	bidang: {
		label: 'Apakah bidang pekerjaan anda sekarang?',
		type: 'dropdown',
		source: [
			'Perkhidmatan',
			'Perladangan',
			'Pertanian',
			'Penternakan',
			'Pelancongan',
			'Perindustrian',
			'Perlombongan & Pengkuarian',
			'Pembinaan',
			'Lain-lain'
		],
		show: function(){
			var sektor = {
				'1': true,
				'2': true,
				'3': false,
				'4': false,
				'5': false,
				'6': true
			}
			
			return sektor[kk.sektor];
		}
	},
	tak_kerja: {
		label: 'Apakah sebab utama anda Tidak Bekerja?',
		type: 'dropdown',
		source: {
			'1': 'Tiada kerja yang sesuai',
			'2': 'Surirumah',
			'3': 'Bersekolah',
			'4': 'Akan melanjutkan pelajaran',
			'5': 'Kecacatan/Hilang upaya',
			'6': 'Tiada minat',
			'7': 'Bersara',
			'8': 'Terlalu muda',
			'9': 'Lain-lain'
		},
		show: function(){
			var sektor = {
				'1': false,
				'2': false,
				'3': false,
				'4': false,
				'5': true,
				'6': false
			}
			
			return sektor[kk.sektor];
		}
	},
	u_bidang: {
		label: 'Apakah kluster/bidang perniagaan anda?',
		type: 'dropdown',
		source: {
			'1': 'Otomotif',
			'2': 'Pembinaan',
			'3': 'Makanan dan Minuman',
			'4': 'Kesejahteraan',
			'5': 'ICT dan Kreatif ICT',
			'6': 'Gaya Hidup',
			'7': 'Teknologi Tinggi',
			'8': 'Pertanian',
			'9': 'Perkhidmatan',
			'10': 'Lain-lain'
		},
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[kk.sektor];
		}
	},
	no_ssm: {
		label: 'Nyatakan no pendaftaran SSM syarikat anda, Jika ADA.',
		type: 'text',
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[kk.sektor];
		}
	},
	lokasi: {
		label: 'Dimanakah lokasi projek/perniagaan anda?',
		type: 'dropdown',
		source: [
			'Dalam wilayah Ketengah',
			'Luar wilayah Ketengah'
		],
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[kk.sektor];
		}
	},
	online: {
		label: 'Adakah projek/perusahaan yang dijalankan secara online atau offline?',
		type: 'checkbox',
		source: [
			'Online',
			'Offline'
		],
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[kk.sektor];
		}
	},
	pendapatan: {
		label: 'Berapakah anggaran pendapatan kasar bulanan yang diterima oleh anda daripada pelbagai sumber?',
		type: 'dropdown',
		source: {
			'1': 'Kurang daripada RM1,311',
			'2': 'RM1,312 - RM2,477',
			'3': 'RM2,478 - RM4,850',
			'4': 'RM4,851 - RM10,970',
			'5': 'Lebih daripada RM10,971',
			'6': 'Tiada Pendapatan'
		},
		show: function(){
			var sektor = {'1': true, '2': true, '3': true, '4': true, '5': false, '6': true };
			return sektor[kk.sektor];
		}
	},
	belanja: {
		label: 'Berapa anggaran perbelanjaan bulanan oleh anda?',
		type: 'dropdown',
		source: {
			'1': 'Kurang daripada RM2,500.00',
			'2': 'RM2,500.00 - RM5,000.00',
			'3': 'Lebih daripada RM5,000.00'
		},
		show: function(){
			var sektor = {'1': true, '2': true, '3': true, '4': true, '5': false, '6': true };
			return sektor[kk.sektor];
		}
	},
	migrasi: {
		label: 'Migrasi',
		type: 'group'
	},
	
	asal_ketengah: {
		label: 'Di manakah tempat tinggal anda sebelum ini?',
		type: 'radio',
		source: {
			'Ya': 'Saya menetap di wilayah KETENGAH',
			'Tidak': 'Saya tidak menetap di wilayah KETENGAH'
		}
	},
	negeri: {
		label: 'Negeri asal anda',
		type: 'dropdown',
		source: [
			'Johor',
			'Kedah',
			'Kelantan',
			'Melaka',
			'Negeri Sembilan',
			'Pahang',
			'Perak',
			'Perlis',
			'Pulau Pinang',
			'Sabah',
			'Sarawak',
			'Selangor',
			'Terengganu',
			'Wilayah Persekutuan'
		],
		show: function (){
			return kk.asal_ketengah == 'Tidak' ? true : false;
		}
	},
	tempoh_menetap: {
		label: 'Sudah berapa lamakah anda menetap di Wilayah Ini?',
		type: 'dropdown',
		source: {
			'1': 'Kurang dari setahun',
			'2': '1-4 tahun',
			'3': '5-10 tahun',
			'4': '11-15 tahun',
			'6': '16-20 tahun',
			'5': '20 tahun ke atas'
		},
		order: ['1','2','3','4','6','5'],
		show: function (){
			return kk.asal_ketengah == 'Tidak' ? true : false;
		}
	},
	faktor: {
		label: 'Apakah faktor-faktor anda menetap di sini?',
		type: 'dropdown',
		source: {
			'1': 'Arahan majikan',
			'2': 'Peluang pekerjaan',
			'3': 'Perkahwinan',
			'4': 'Melanjutkan pelajaran',
			'5': 'Lain-lain'
		},
		show: function (){
			return kk.asal_ketengah == 'Tidak' ? true : false;
		}
	},
	
	ahli_keluarga: {
		label: 'Berapakah jumlah ahli keluarga yang telah berhijrah dari KETENGAH?',
		type: 'number',
		
	},
	pendidikan: {
		label: 'Pendidikan',
		type: 'group'
	},
	kebolehan: {
		label: 'Adakah anda berkebolehan untuk Membaca, Menulis dan Mengira?',
		type: 'checkbox',
		source: [
			'Membaca',
			'Menulis',
			'Mengira'
		]
	},
	masih: {
		label: 'Adakah anda masih belajar?',
		type: 'dropdown',
		source: {
			'1': 'Masih Belajar',
			'2': 'Telah Tamat Belajar',
			'3': 'Tidak Pernah Bersekolah',
			'4': 'Tidak Tamat Belajar'
		}
	},
	sebab: {
		label: 'Nyatakan sebab anda tidak pernah bersekolah',
		type: 'checkbox',
		source: [
			'Cacat/Masalah Penglihatan',
			'Masalah Perbelanjaan',
			'Masalah Pengangkutan',
			'Masalah Keluarga',
			'Tidak Berminat',
			'Lain-lain'
		],
		show: function (){
			return kk.masih == '3' ? true : false;
		}
	},
	tahap: {
		label: 'Apakah tahap pengajian tertinggi yang dicapai/masih menuntut oleh anda?',
		type: 'dropdown',
		source: {
			'1': 'Doktor Falsafah',
			'2': 'Sarjana',
			'3': 'Ijazah',
			'4': 'Diploma',
			'5': 'Sijil',
			'6': 'STPM/HSC',
			'7': 'SPM/MCE',
			'8': 'PMR/SRP/LCE',
			'9': 'UPSR & Lain-lain'
		},
		show: function (){
			return kk.masih == '3' ? false : true;
		}
	},
	kemudahan: {
		label: 'Adakah anda mempunyai kemudahan dalam pembelajaran?',
		type: 'checkbox',
		source: [
			'Komputer Peribadi',
			'E-book',
			'Tablet',
			'Telefon Pintar',
			'Lain-lain',
			'Tiada'
		],
		show: function (){
			return kk.masih == '3' ? false : true;
		}
	},
	kebajikan: {
		label: 'Kebajikan',
		type: 'group'
	},
	bantuan: {
		label: 'Adakah anda pernah menerima bantuan?',
		type: 'radio',
		source: {
			'1': 'Ya',
			'2': 'Tidak'
		}
	},
	
	bantuan_ketengah: {
		label: 'Sekiranya YA, apakah jenis bantuan tersebut?',
		type: 'dropdown',
		source: {
			'PLKK': 'PLKK (Program Latihan Kemahiran dan Kerjaya)',
			'PPMI': 'PPMI (Program Pembangunan Modal Insan)',
			'PPP': 'PPP (Program Peningkatan Pendapatan)',
			'PPRT - Baik Pulih': 'PPRT (Program Perumahan Rakyat Termiskin)-Baik Pulih',
			'PPRT - Bina Baru': 'PPRT (Program Perumahan Rakyat Termiskin)-Bina Baru',
			'PPEK': 'PPEK (Program Peningkatan Ekonomi Kampung)',
			'TAMK': 'TAMK (Tabung Amanah Masyarakat Ketengah)',
			'Bantuan Bencana': 'Bantuan Bencana',
			'SPKLB': 'SPKLB (Sokongan Pengukuhan Keusahawanan Luar Bandar)'
		},
		show: function(){
			return kk.oku != '3' && kk.bantuan == '1' ? true : false
		}
	},
	jenis_bantuan: {
		label: 'Sekiranya TIDAK, apakah jenis bantuan/ insentif yang diperlukan?',
		type: 'dropdown',
		source: {
			'PLKK': 'PLKK (Program Latihan Kemahiran dan Kerjaya)',
			'PPMI': 'PPMI (Program Pembangunan Modal Insan)',
			'PPP': 'PPP (Program Peningkatan Pendapatan)',
			'PPRT - Baik Pulih': 'PPRT (Program Perumahan Rakyat Termiskin)-Baik Pulih',
			'PPRT - Bina Baru': 'PPRT (Program Perumahan Rakyat Termiskin)-Bina Baru',
			'PPEK': 'PPEK (Program Peningkatan Ekonomi Kampung)',
			'TAMK': 'TAMK (Tabung Amanah Masyarakat Ketengah)',
			'Bantuan Bencana': 'Bantuan Bencana',
			'SPKLB': 'SPKLB (Sokongan Pengukuhan Keusahawanan Luar Bandar)'
		},
		show: function(){
			return kk.oku != '3' && kk.bantuan == '2' ? true : false
		}
	},
	selain_ketengah: {
		label: 'Jika anda pernah menerima bantuan selain KETENGAH, Nyatakan',
		type: 'text'
	},
	latihan: {
		label: 'Adakah anda memerlukan bantuan latihan?',
		type: 'dropdown',
		source: [
			'Ya, Latihan Kemahiran',
			'Ya, Latihan Bukan Kemahiran',
			'Tidak'
		]
	},
	ekasih: {
		label: 'Adakah anda berdaftar dengan e-Kasih?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		]
	},
	penerima_ekasih:  {
		label: 'Sekiranya YA, adakah anda menerima bantuan?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		],
		show: function(){
			return kk.ekasih == 'Ya' ? true : false
		}
	},
	jenis_ekasih: {
		label: 'Sekiranya YA, apakah jenis bantuan yang diterima?',
		type: 'checkbox',
		source: [
			'MAIDAM',
			'JKM',
			'PPRT - Bina Baru',
			'PPRT - Baikpulih',
			'Bantuan one-off'
		],
		show: function (){
			return kk.ekasih == 'Ya' && kk.penerima_ekasih == 'Ya' ? true : false
		}
	},
	
	teknologi: {
		label: 'Teknologi',
		type: 'group'
	},
	media_sosial: {
		label: 'Adakah anda mempunyai akaun media sosial berikut?',
		type: 'checkbox',
		source: [
			'Facebook',
			'WhatsApp',
			'Instagram',
			'Twitter',
			'Lain-lain',
			'Tiada'
		]
	},
	internet: {
		label: 'Bagaimanakah anda mendapatkan capaian internet?',
		type: 'checkbox',
		source: {
			'Talian Tetap Internet di Rumah': 'Talian Tetap Internet di Rumah (contoh: Unifi / Streamyx)',
			'Talian Internet Telefon Pintar': 'Talian Internet Telefon Pintar',
			'Talian Internet di Pusat Komuniti Desa (PKD)': 'Talian Internet di Pusat Komuniti Desa (PKD)',
			'Lain-lain': 'Lain-lain',
			'Tiada': 'Tiada'
		}
	},
	jum_tel: {
		label: 'Berapakah jumlah telefon pintar / tablet yang anda miliki?',
		type: 'number'
	},
	jum_kom: {
		label: 'Berapakah jumlah PC / Laptop yang anda miliki?',
		type: 'number'
	},
	kemahiran: {
		label: 'Nyatakan tahap kemahiran anda menggunakan perisian komputer?',
		type: 'dropdown',
		source: [
			'Sangat Mahir',
			'Mahir',
			'Kurang Mahir',
			'Tidak Tahu Menggunakan'
		]	
	},
	telco: {
		label: 'Apakah perkhidmatan telco yang digunakan?',
		type: 'checkbox',
		source: [
			'Celcom',
			'Maxis',
			'Digi',
			'UMobile',
			'Lain-lain',
			'Tiada'
		]
	},
	tujuan: {
		label: 'Apakah tujuan penggunaan Internet anda?',
		type: 'checkbox',
		source: [
			'Internet Banking',
			'eGovernment',
			'Media Sosial',
			'Pembelian Online',
			'Penjualan Online',
			'Pengajaran dan Pembelajaran di Rumah (PdPr)',
			'Lain-lain',
			'Tiada'
		]
	},
	kemahiran: {
		label: 'Nyatakan tahap kemahiran anda menggunakan perisian komputer?',
		type: 'dropdown',
		source: [
			'Sangat Mahir',
			'Mahir',
			'Kurang Mahir',
			'Tidak Tahu Menggunakan'
		]
	}
}

var qIsiRumah = {
	_object_bind: 'ir',
	profil_umum: {
		label: 'Profil Umum',
		type: 'group'	
	},
	hubungan: {
		label: 'Apakah hubungan anda rumah dengan Ketua Keluarga',
		type: 'dropdown',
		source: {
			'1': 'Isteri/Suami',
			'2': 'Anak Yang Belum Berkahwin',
			'3': 'Anak Yang Sudah Berkahwin',
			'4': 'Menantu Perempuan/Lelaki',
			'5': 'Cucu',
			'6': 'Bapa/Ibu Responden Atau Kepada Pasangan',
			'7': 'Abang/Kakak/Adik Responden atau Pasangan',
			'8': 'Orang lain yang bersaudara',
			'9': 'Orang lain yang tidak bersaudara'
		}
	},
	ada_kp: {
		label: 'Adakah anda mempunyai dokumen pengenalan diri?',
		type: 'radio',
		source: ["Ya", "Tidak"]
	},
	jenis_kp: {
		label: 'Jenis Kad Pengenalan',
		type: 'dropdown',
		source: {
			'1': 'No.: MyKad / MyKid / MyPR / MyKAS / MyTentera',
			'2': 'No.: K.P. Lama / Tentera / Polis / Sijil Lahir / Pasport / Dokumen Lain',
			'3': 'No. Permit Kerja',
			'4': 'No. Pasport'
		},
		show: function(){
			return ir.ada_kp == 'Ya' ? true : false
		}
	},
	no_ic: {
		label: 'No Kad Pengenalan (tanpa simbol -)',
		type: 'text',
		show: function(){
			
			if (ir.no_ic){
				if (ir.no_ic.length == 12){
					var yy = ir.no_ic.charAt(0) + ir.no_ic.charAt(1);
					var mm = ir.no_ic.charAt(2) + ir.no_ic.charAt(3);
					var dd = ir.no_ic.charAt(4) + ir.no_ic.charAt(5);
					
					if (yy > 25){
						yy = 1900+parseInt(yy);
					} else {
						yy = 2000+parseInt(yy);
					}
					
					var birthday = new Date(yy, parseInt(mm), parseInt(dd));
					var ageDifMs = Date.now() - birthday.getTime();
					var ageDate = new Date(ageDifMs);
					var age = Math.abs(ageDate.getUTCFullYear() - 1970);
					
					if (ir.no_ic.charAt(ir.no_ic.length-1) % 2 == 0){
						document.querySelector('input[value=Perempuan]').checked = true;
					} else {
						document.querySelector('input[value=Lelaki]').checked = true;
					}
					
					document.querySelector('input[name=tarikh_lahir]').value = yy + '-' + mm + '-' + dd;
					document.querySelector('input[name=umur]').value = age;
				}
			}
			
			return ir.ada_kp == 'Ya' ? true : false
		}
	},
	nama: {
		label: "Nama",
		type: 'text'
	},
	no_tel: {
		label: 'No Telefon',
		type: 'tel'
	},
	emel: {
		label: 'Emel',
		type: 'email'
	},
	jantina: {
		label: 'Jantina',
		type: 'radio',
		source: ["Lelaki", "Perempuan"]
	},
	tarikh_lahir: {
		label: 'Tarikh Lahir',
		type: 'date',
	},
	tempat_lahir: {
		label: 'Dimanakah tempat lahir anda?',
		type: 'dropdown',
		source: [
			'Johor',
			'Kedah',
			'Kelantan',
			'Melaka',
			'Negeri Sembilan',
			'Pahang',
			'Perak',
			'Perlis',
			'Pulau Pinang',
			'Sabah',
			'Sarawak',
			'Selangor',
			'Terengganu',
			'Wilayah Persekutuan'
		]
	},
	umur: {
		label: 'Umur',
		type: 'number'
	},
	kaum: {
		label: 'Kaum',
		type: 'dropdown',
		source: [
			'Melayu',
			'Cina',
			'India',
			'Lain-lain'
		],
	},
	agama: {
		label: 'Agama',
		type: 'dropdown',
		source: [
			'Islam',
			'Buddha',
			'Hindu',
			'Kristian',
			'Tiada Agama',
			'Lain-lain'
		]
	},
	status_kahwin: {
		label: 'Taraf Perkahwinan',
		type: 'dropdown',
		source: {
			'1': 'Tidak pernah berkahwin',
			'2': 'Berkahwin',
			'3': 'Balu/Duda',
			'4': 'Bercerai/Berpisah tetap'
		}
	},
	bil_anak: {
		label: 'Bilangan Anak',
		type: 'number',
		show: function(){
			return ir.status_kahwin == '1' ? false : true
		}
	},
	warganegara: {
		label: 'Adakah anda Warganegara Malaysia?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		]
	},
	tahun_my: {
		label: 'Berapa tahun anda telah berada di Malaysia?',
		type: 'dropdown',
		source: {
			'4': 'Kurang daripada 1 tahun',
			'1': '1-10 tahun',
			'2': '11-20 tahun',
			'3': '21 tahun ke atas'
		},
		show: function(){
			return ir.warganegara == 'Tidak' ? true : false
		}
	},
	status_duduk: {
		label: 'Apakah status kependudukan anda?',
		type: 'dropdown',
		source: [
			'Penduduk Tetap',
			'Ekspatriat',
			'Pelawat Asing',
			'Pekerja Asing',
			'Lain-lain'
		],
		show: function(){
			return ir.warganegara == 'Tidak' ? true : false
		}
	},
	tanah_lain: {
		label: 'Adakah anda mempunyai tanah selain daripada tanah pemilikan di dalam wilayah Ketengah ?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		]
	},
	lesen: {
		label: 'Lesen kenderaan yang anda miliki?',
		type: 'checkbox',
		source: [
			'B2-Motosikal',
			'B-Motosikal 500cc',
			'D-Kereta',
			'E-Lori',
			'E-GDL',
			'D-GDL',
			'PSV-Konduktor',
			'PSV-Bas',
			'PSV-Teksi',
			'Tiada'
		]
	},
	oku: {
		label: 'Adakah anda merupakan orang kurang upaya (OKU)',
		type: 'dropdown',
		source: {
			'1': 'Ya',
			'3': 'Tidak'
		}
	},
	penyakit: {
		label: 'Adakah anda telah disahkan menghidap penyakit berikut sekarang',
		type: 'checkbox',
		source: [
			'Kencing manis',
			'Darah tinggi',
			'Jantung',
			'Lain-lain',
			'Tiada'
		]
	},
	insurans: {
		label: 'Adakah anda mempunyai perlindungan insurans kesihatan?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		]
	},
	pekerjaan: {
		label: 'Pekerjaan',
		type: 'group'
	},
	sektor: {
		label: 'Sektor Pekerjaan',
		type: 'dropdown',
		source: {
			'1': 'Sektor Awam',
			'2': 'Sektor Swasta',
			'3': 'Usahawan / Bekerja Sendiri',
			'5': 'Tidak Bekerja',
			'6': 'Lain-lain'
		}
	},
	pengangkutan: {
		label: 'Bagaimanakah anda ke tempat kerja?',
		type: 'checkbox',
		source: [
			'Kenderaan awam',
			'Motosikal',
			'Kereta',
			'Basikal',
			'Berjalan Kaki'
		],
		show: function(){
			return ir.sektor == '5' ? false : true
		}
	},
	jarak: {
		label: 'Berapakah jarak kediaman ke tempat kerja?',
		type: 'dropdown',
		source: {
			'6': 'Kurang daripada 1KM',
			'1': '1-5KM',
			'2': '5-10KM',
			'3': '10-15KM',
			'4': '15-20KM',
			'5': 'Lebih dari 20KM'
		},
		order: ['6','1','2','3','4','5'],
		show: function(){
			return ir.sektor == '5' ? false : true
		}
	},
	bidang: {
		label: 'Apakah bidang pekerjaan anda sekarang?',
		type: 'dropdown',
		source: [
			'Perkhidmatan',
			'Perladangan',
			'Pertanian',
			'Penternakan',
			'Pelancongan',
			'Perindustrian',
			'Perlombongan & Pengkuarian',
			'Pembinaan',
			'Lain-lain'
		],
		show: function(){
			var sektor = {
				'1': true,
				'2': true,
				'3': false,
				'4': false,
				'5': false,
				'6': true
			}
			
			return sektor[ir.sektor];
		}
	},
	tak_kerja: {
		label: 'Apakah sebab utama anda Tidak Bekerja?',
		type: 'dropdown',
		source: {
			'1': 'Tiada kerja yang sesuai',
			'2': 'Surirumah',
			'3': 'Bersekolah',
			'4': 'Akan melanjutkan pelajaran',
			'5': 'Kecacatan/Hilang upaya',
			'6': 'Tiada minat',
			'7': 'Bersara',
			'8': 'Terlalu muda',
			'9': 'Lain-lain'
		},
		show: function(){
			var sektor = {
				'1': false,
				'2': false,
				'3': false,
				'4': false,
				'5': true,
				'6': false
			}
			
			return sektor[ir.sektor];
		}
	},
	u_bidang: {
		label: 'Apakah kluster/bidang perniagaan anda?',
		type: 'dropdown',
		source: {
			'1': 'Otomotif',
			'2': 'Pembinaan',
			'3': 'Makanan dan Minuman',
			'4': 'Kesejahteraan',
			'5': 'ICT dan Kreatif ICT',
			'6': 'Gaya Hidup',
			'7': 'Teknologi Tinggi',
			'8': 'Pertanian',
			'9': 'Perkhidmatan',
			'10': 'Lain-lain'
		},
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[ir.sektor];
		}
	},
	no_ssm: {
		label: 'Nyatakan no pendaftaran SSM syarikat anda, Jika ADA.',
		type: 'text',
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[ir.sektor];
		}
	},
	lokasi: {
		label: 'Dimanakah lokasi projek/perniagaan anda?',
		type: 'dropdown',
		source: [
			'Dalam wilayah Ketengah',
			'Luar wilayah Ketengah'
		],
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[ir.sektor];
		}
	},
	online: {
		label: 'Adakah projek/perusahaan yang dijalankan secara online atau offline?',
		type: 'checkbox',
		source: [
			'Online',
			'Offline'
		],
		show: function(){
			var sektor = {'1': false, '2': false, '3': true, '4': true, '5': false, '6': false };
			return sektor[ir.sektor];
		}
	},
	pendapatan: {
		label: 'Berapakah anggaran pendapatan kasar bulanan yang diterima oleh anda daripada pelbagai sumber?',
		type: 'dropdown',
		source: {
			'1': 'Kurang daripada RM1,311',
			'2': 'RM1,312 - RM2,477',
			'3': 'RM2,478 - RM4,850',
			'4': 'RM4,851 - RM10,970',
			'5': 'Lebih daripada RM10,971',
			'6': 'Tiada Pendapatan'
		},
		show: function(){
			var sektor = {'1': true, '2': true, '3': true, '4': true, '5': false, '6': true };
			return sektor[ir.sektor];
		}
	},
	belanja: {
		label: 'Berapa anggaran perbelanjaan bulanan oleh anda?',
		type: 'dropdown',
		source: {
			'1': 'Kurang daripada RM2,500.00',
			'2': 'RM2,500.00 - RM5,000.00',
			'3': 'Lebih daripada RM5,000.00'
		},
		show: function(){
			var sektor = {'1': true, '2': true, '3': true, '4': true, '5': false, '6': true };
			return sektor[ir.sektor];
		}
	},
	migrasi: {
		label: 'Migrasi',
		type: 'group'
	},
	asal_ketengah: {
		label: 'Di manakah tempat tinggal anda sebelum ini?',
		type: 'radio',
		source: {
			'Ya': 'Saya menetap di wilayah KETENGAH',
			'Tidak': 'Saya tidak menetap di wilayah KETENGAH'
		}
	},
	negeri: {
		label: 'Negeri asal anda',
		type: 'dropdown',
		source: [
			'Johor',
			'Kedah',
			'Kelantan',
			'Melaka',
			'Negeri Sembilan',
			'Pahang',
			'Perak',
			'Perlis',
			'Pulau Pinang',
			'Sabah',
			'Sarawak',
			'Selangor',
			'Terengganu',
			'Wilayah Persekutuan'
		],
		show: function (){
			return ir.asal_ketengah == 'Tidak' ? true : false;
		}
	},
	tempoh_menetap: {
		label: 'Sudah berapa lamakah anda menetap di Wilayah Ini?',
		type: 'dropdown',
		source: {
			'1': 'Kurang dari setahun',
			'2': '1-4 tahun',
			'3': '5-10 tahun',
			'4': '11-15 tahun',
			'6': '16-20 tahun',
			'5': '21 tahun ke atas'
		},
		order: ['1','2','3','4','6','5'],
		show: function (){
			return ir.asal_ketengah == 'Tidak' ? true : false;
		}
	},
	faktor: {
		label: 'Apakah faktor-faktor anda menetap di sini?',
		type: 'dropdown',
		source: {
			'1': 'Arahan majikan',
			'2': 'Peluang pekerjaan',
			'3': 'Perkahwinan',
			'4': 'Melanjutkan pelajaran',
			'5': 'Lain-lain'
		},
		show: function (){
			return ir.asal_ketengah == 'Tidak' ? true : false;
		}
	},
	
	pendidikan: {
		label: 'Pendidikan',
		type: 'group'
	},
	kebolehan: {
		label: 'Adakah anda berkebolehan untuk Membaca, Menulis dan Mengira?',
		type: 'checkbox',
		source: [
			'Membaca',
			'Menulis',
			'Mengira'
		]
	},
	masih: {
		label: 'Adakah anda masih belajar?',
		type: 'dropdown',
		source: {
			'1': 'Masih Belajar',
			'2': 'Telah Tamat Belajar',
			'3': 'Tidak Pernah Bersekolah',
			'4': 'Tidak Tamat Belajar'
		}
	},
	sebab: {
		label: 'Nyatakan sebab anda tidak pernah bersekolah',
		type: 'checkbox',
		source: [
			'Cacat/Masalah Penglihatan',
			'Masalah Perbelanjaan',
			'Masalah Pengangkutan',
			'Masalah Keluarga',
			'Tidak Berminat',
			'Lain-lain'
		],
		show: function (){
			return ir.masih == '3' ? true : false;
		}
	},
	tahap: {
		label: 'Apakah tahap pengajian tertinggi yang dicapai/masih menuntut oleh anda?',
		type: 'dropdown',
		source: {
			'1': 'Doktor Falsafah',
			'2': 'Sarjana',
			'3': 'Ijazah',
			'4': 'Diploma',
			'5': 'Sijil',
			'6': 'STPM/HSC',
			'7': 'SPM/MCE',
			'8': 'PMR/SRP/LCE',
			'9': 'UPSR & Lain-lain'
		},
		show: function (){
			return ir.masih == '3' ? false : true;
		}
	},
	kemudahan: {
		label: 'Adakah anda mempunyai kemudahan dalam pembelajaran?',
		type: 'checkbox',
		source: [
			'Komputer Peribadi',
			'E-book',
			'Tablet',
			'Telefon Pintar',
			'Lain-lain',
			'Tiada'
		],
		show: function (){
			return ir.masih == '3' ? false : true;
		}
	},
	kebajikan: {
		label: 'Kebajikan',
		type: 'group'
	},
	bantuan: {
		label: 'Adakah anda pernah menerima bantuan?',
		type: 'radio',
		source: {
			'1': 'Ya',
			'3': 'Tidak'
		}
	},
	bantuan_ketengah: {
		label: 'Sekiranya YA, apakah jenis bantuan tersebut?',
		type: 'dropdown',
		source: {
			'PLKK': 'PLKK (Program Latihan Kemahiran dan Kerjaya)',
			'PPMI': 'PPMI (Program Pembangunan Modal Insan)',
			'PPP': 'PPP (Program Peningkatan Pendapatan)',
			'PPRT - Baik Pulih': 'PPRT (Program Perumahan Rakyat Termiskin)-Baik Pulih',
			'PPRT - Bina Baru': 'PPRT (Program Perumahan Rakyat Termiskin)-Bina Baru',
			'PPEK': 'PPEK (Program Peningkatan Ekonomi Kampung)',
			'TAMK': 'TAMK (Tabung Amanah Masyarakat Ketengah)',
			'Bantuan Bencana': 'Bantuan Bencana',
			'SPKLB': 'SPKLB (Sokongan Pengukuhan Keusahawanan Luar Bandar)'
		},
		show: function(){
			return ir.oku != '3' && ir.bantuan == '1' ? true : false
		}
	},
	jenis_bantuan: {
		label: 'Sekiranya TIDAK, apakah jenis bantuan/ insentif yang diperlukan?',
		type: 'dropdown',
		source: {
			'PLKK': 'PLKK (Program Latihan Kemahiran dan Kerjaya)',
			'PPMI': 'PPMI (Program Pembangunan Modal Insan)',
			'PPP': 'PPP (Program Peningkatan Pendapatan)',
			'PPRT - Baik Pulih': 'PPRT (Program Perumahan Rakyat Termiskin)-Baik Pulih',
			'PPRT - Bina Baru': 'PPRT (Program Perumahan Rakyat Termiskin)-Bina Baru',
			'PPEK': 'PPEK (Program Peningkatan Ekonomi Kampung)',
			'TAMK': 'TAMK (Tabung Amanah Masyarakat Ketengah)',
			'Bantuan Bencana': 'Bantuan Bencana',
			'SPKLB': 'SPKLB (Sokongan Pengukuhan Keusahawanan Luar Bandar)'
		},
		show: function(){
			return ir.oku != '3' && ir.bantuan == '2' ? true : false
		}
	},
	selain_ketengah: {
		label: 'Jika anda pernah menerima bantuan selain KETENGAH, Nyatakan',
		type: 'text'
	},
	latihan: {
		label: 'Adakah anda memerlukan bantuan latihan?',
		type: 'dropdown',
		source: [
			'Ya, Latihan Kemahiran',
			'Ya, Latihan Bukan Kemahiran',
			'Tidak'
		],
		show: function (){
			return ir.oku != '3' ? false : true
		}
	},
	ekasih: {
		label: 'Adakah anda berdaftar dengan e-Kasih?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		],
		show: function(){
			return ir.oku != '3' ? true : false
		}
	},
	penerima_ekasih:  {
		label: 'Sekiranya YA, adakah anda menerima bantuan?',
		type: 'radio',
		source: [
			'Ya',
			'Tidak'
		],
		show: function(){
			return ir.oku != '3' && ir.ekasih == 'Ya' ? true : false
		}
	},
	jenis_ekasih: {
		label: 'Sekiranya YA, apakah jenis bantuan yang diterima?',
		type: 'checkbox',
		source: [
			'MAIDAM',
			'JKM',
			'PPRT - Bina Baru',
			'PPRT - Baikpulih',
			'Bantuan one-off'
		],
		show: function (){
			return ir.oku != '3' && ir.ekasih == 'Ya' && ir.penerima_ekasih == 'Ya' ? true : false
		}
	},
	
	teknologi: {
		label: 'Teknologi',
		type: 'group'
	},
	media_sosial: {
		label: 'Adakah anda mempunyai akaun media sosial berikut?',
		type: 'checkbox',
		source: [
			'Facebook',
			'WhatsApp',
			'Instagram',
			'Twitter',
			'Lain-lain',
			'Tiada'
		]
	},
	internet: {
		label: 'Bagaimanakah anda mendapatkan capaian internet?',
		type: 'checkbox',
		source: {
			'Talian Tetap Internet di Rumah': 'Talian Tetap Internet di Rumah (contoh: Unifi / Streamyx)',
			'Talian Internet Telefon Pintar': 'Talian Internet Telefon Pintar',
			'Talian Internet di Pusat Komuniti Desa (PKD)': 'Talian Internet di Pusat Komuniti Desa (PKD)',
			'Lain-lain': 'Lain-lain',
			'Tiada': 'Tiada'
		}
	},
	jum_tel: {
		label: 'Berapakah jumlah telefon pintar / tablet yang anda miliki?',
		type: 'number'
	},
	jum_kom: {
		label: 'Berapakah jumlah PC / Laptop yang anda miliki?',
		type: 'number'
	},
	kemahiran: {
		label: 'Nyatakan tahap kemahiran anda menggunakan perisian komputer?',
		type: 'dropdown',
		source: [
			'Sangat Mahir',
			'Mahir',
			'Kurang Mahir',
			'Tidak Tahu Menggunakan'
		]	
	},
	telco: {
		label: 'Apakah perkhidmatan telco yang digunakan?',
		type: 'checkbox',
		source: [
			'Celcom',
			'Maxis',
			'Digi',
			'UMobile',
			'Lain-lain',
			'Tiada'
		]
	},
	tujuan: {
		label: 'Apakah tujuan penggunaan Internet anda?',
		type: 'checkbox',
		source: [
			'Internet Banking',
			'eGovernment',
			'Media Sosial',
			'Pembelian Online',
			'Penjualan Online',
			'Pengajaran dan Pembelajaran di Rumah (PdPr)',
			'Lain-lain',
			'Tiada'
		]
	},
	kemahiran: {
		label: 'Nyatakan tahap kemahiran anda menggunakan perisian komputer?',
		type: 'dropdown',
		source: [
			'Sangat Mahir',
			'Mahir',
			'Kurang Mahir',
			'Tidak Tahu Menggunakan'
		]
	}
}